<?php
//##copyright##

if (iaView::REQUEST_HTML == $iaView->getRequestType())
{
	$action = isset($iaCore->requestPath[0]) ? iaCore::ACTION_READ : 'list';
	$curitem = '';

	$iaItems = $iaCore->factory('item', iaCore::CORE);
	$items = $iaItems->getItems();

	$exists = $iaDb->keyvalue('`item`, `id`', null, 'reviews_items');

	$reviews_items = array();
	foreach ($items as $key => $item)
	{
		if ($item != iaCore::CORE)
		{
			$reviews_items[$item] = array(
				'value' => $item,
				'title' => strtoupper(iaLanguage::get($item, $item)),
				'type' => isset($exists[$item]) ? 'used' : 'not_used',
			);
		}
	}
	if (iaCore::ACTION_READ == $action)
	{
		$item = $iaCore->requestPath[0];
		$texts = array();

		if (!isset($reviews_items[$item]))
		{
			return iaView::errorPage(iaView::ERROR_NOT_FOUND);
		}
		if ($reviews_items[$item]['type'] == 'used' && isset($_GET['delete']))
		{
			$action = iaCore::ACTION_DELETE;
		}
		else
		{
			if (isset($_POST['star_texts']))
			{
				$list = $_POST['star_texts'];
				foreach ($list as $key => $value)
				{
					if (trim($value) != '')
					{
						$array = explode(PHP_EOL, $value);
						$texts[$key] = array(
							'title' => isset($_POST['titles'][$key]) ? iaSanitize::sql($_POST['titles'][$key]) : '',
							'list' => array()
						);
						foreach ($array as $v)
						{
							if ($v)
							{
								$texts[$key]['list'][] = $v;
							}
						}
						if (empty($texts[$key]['list']))
						{
							unset($texts[$key]);
						}
						else
						{
							$texts[$key]['list'] = str_replace(array("\n", "\r", "\t"), '', implode('||', $texts[$key]['list']));
						}
					}
				}
				$entry = array(
					'item' => $item,
					'star_texts' => serialize($texts),
					'review_allowed' => (int)$_POST['review_allowed'],
					'comment_allowed' => (int)$_POST['comment_allowed']
				);
				if ($reviews_items[$item]['type'] == 'not_used')
				{
					$reviews_items[$item]['type'] = 'used';
					$exists[$item] = $iaDb->insert($entry, null, 'reviews_items');
				}
				else
				{
					$entry['id'] = $exists[$item];
					$iaDb->update($entry, null, null, 'reviews_items');
				}
			}

			if (isset($exists[$item]))
			{
				$field = $iaDb->row(iaDb::ALL_COLUMNS_SELECTION, "`id` = '{$exists[$item]}'", 'reviews_items');
				$iaView->assign('texts', unserialize($field['star_texts']));
				$iaView->assign('field', $field);
			}
			$curitem = strtoupper($item);
		}
	}

	iaBreadcrumb::add(iaLanguage::get('manage_reviews'), IA_ADMIN_URL . 'manage/reviews/');

	$iaView->assign('curitem', $curitem);
	$iaView->assign('reviews_items', $reviews_items);
	$iaView->assign('action', $action);

	$iaView->display('config');
}