<div class="reviews__list">
	{foreach $review_texts as $item}
		{assign var='owned' value=(($member && $item.member_id == $member.id) || (!$member && $item.session_id == $session_id))}

		<div id="review_{$item.id}" class="reviews__item{if $owned} reviews__item--owned{/if}">
			<div class="reviews__item__author clearfix">
				{if empty($item.username)}
					<p class="reviews__item__author__name">
						<img src="{$img}no-avatar.png" width="40" class="img-circle pull-left" alt="">
						{lang key='guest'}
					</p>
				{else}
					<p class="reviews__item__author__name">
						<a href="{ia_url type='url' item='members' data=$member}">
							{if $member.avatar}
								{assign var='avatar' value=$member.avatar|unserialize}
								{printImage imgfile=$avatar.path width=40 class='img-circle pull-left' title=$member.fullname}
							{else}
								<img src="{$img}no-avatar.png" width="40" class="img-circle pull-left" alt="">
							{/if}
						</a>
						<a href="{ia_url type='url' item='members' data=$member}">{$member.fullname}</a>
					</p>
				{/if}
					
				<div class="reviews__item__rating">
					{foreach $item.review_rates|unserialize as $key => $rate}
						{assign var="max_star" value=$configuration.star_texts[$key].list|@count}
						<div class="fl">
							<div class="fl rgray" style="width:{$max_star*16}px;">
								<div class="rgold" style="width:{$rate*16}px;">&nbsp;</div>
							</div>
						</div>
					{/foreach}
				</div>
			</div>
			<div class="reviews__item__text">
				{$item.review_text}
			</div>
			
			<div class="reviews__item__info">
				<span class="reviews__item__date">{lang key='on'} {$item.date_added|date_format:$config.date_format}</span>

				<span class="reviews__item__likes">
					<a href="javascript:;" class="like" data-itemid="{$item.id}" {if $owned}disabled="disabled"{/if} title="{lang key='review_like'}">
						<i class="icon-thumbs-up"></i>  <span>{$item.users_likes}</span>
					</a> 
					<a href="javascript:;" class="dislike" data-itemid="{$item.id}" {if $owned}disabled="disabled"{/if} title="{lang key='review_dislike'}">
						<i class="icon-thumbs-down"></i> <span>{$item.users_dislikes}</span>
					</a> 
				</span>
				{if $item.comments > 0}
					<span class="reviews__item__comments-link">
						<a href="javascript:;" class="c-show-hide" onclick="toggle_div('comments',{$item.id})" title="{lang key='close_open_comments'}">{lang key='comments'}: {$item.comments}</a>
					</span>
				{/if}
				{if $configuration.comment_allowed}
					<a class="add-comment pull-right" href="javascript:;" onclick="toggle_div('form',{$item.id})">
						<i class="icon-comment"></i> {lang key='post_comment'}
					</a>
				{/if}
			</div>
			<div class="reviews__item__comment-form" id="reviews_form_{$item.id}" style="display: none;">
				<form method="post" action="" class="form-subrion comment-form">
					{preventCsrf}
					<input type="hidden" value="{$item.id}" name="review_id">
					<input type="hidden" value="" name="review_type" id="review_type_{$item.id}">
					{if !$member}
						<b>{lang key='author'}:</b> <input type="text" name="review_author" value="Guest">
					{/if}
					<textarea name="review_comment" class="input-block-level" rows="5"></textarea>
					<button type="submit" class="btn btn-info btn-mini"><i class="icon-comment"></i> {lang key='comment'}</button>
					<button type="button" class="btn btn-danger btn-mini" onclick="toggle_div('form',{$item.id})"><i class="icon-minus-sign"></i> {lang key='cancel'}</button>
				</form>
			</div>
			
			{include file=$smarty.const.IA_PLUGINS|cat:"reviews/templates/front/reviews-comments.tpl"}
			
		</div>
	{/foreach}
</div>
{ia_print_js files='_IA_URL_plugins/reviews/js/frontend/reviews'}
