<?php
//##copyright##

if (!isset($item) || $item == '')
{
	$item = IA_CURRENT_PACKAGE;
}
if (!isset($title))
{
	$title = '';
}

if ($item == 'realestate')
{
	$item = 'estates';
}

if ($item == 'yellowpages')
{
	$item = 'ypages';
}

$limit = 10;
$error = false;
$messages = array();
$comments = false;
$review_comments = array();
$texts = false;
$star_list = array();
$sessionId = session_id();
$userId = iaUsers::hasIdentity() ? iaUsers::getIdentity()->id : 0;
$where_exists = "`item` = '$item'";

$iaItem = $iaCore->factory('item');
$tableName = $iaItem->getItemTable($item);

$itemConfiguration = $iaDb->row(iaDb::ALL_COLUMNS_SELECTION, "`item` = '$item'", 'reviews_items');

$iaCore->startHook('phpReviewsBeforeView', array('field' => &$itemConfiguration));

$listingStatus = $iaDb->one('`status`', iaDb::convertIds($listing), $tableName);

if ($itemConfiguration && iaCore::STATUS_ACTIVE == $listingStatus)
{
	$iaReview = $iaCore->factoryPlugin('reviews', 'common', 'review');

	$itemConfiguration['star_texts'] = empty($itemConfiguration['star_texts']) ? array() : unserialize($itemConfiguration['star_texts']);
	foreach ($itemConfiguration['star_texts'] as $key => $val)
	{
		$itemConfiguration['star_texts'][$key]['list'] = explode('||', $val['list']);
		$star_list[$key] = count($itemConfiguration['star_texts'][$key]['list']);
	}
	$review = $iaDb->row(iaDb::ALL_COLUMNS_SELECTION, "`obj_id` = '$listing' AND `item_type` = '$item'", iaReview::getTable());

	$alreadyReviewed = false;
	if ($review)
	{
		$review['ratings'] = unserialize($review['ratings']);

		$where_exists .= " AND `review_id` = '{$review['id']}'";
		$where_exists .= iaUsers::hasIdentity()
			? sprintf(' AND `member_id` = %d', iaUsers::getIdentity()->id)
			: sprintf(" AND `session_id` = '%s'", $sessionId);

		$alreadyReviewed = $iaDb->exists($where_exists, null, iaReview::getTableClicks());
	}

	if (isset($_POST['review_text']))
	{
		if (!$iaCore->get('reviews_guests_accepted') && !iaUsers::hasIdentity())
		{
			$error = true;
			$messages[] = iaLanguage::get('sign_in_to_rate');
		}
		elseif (!isset($_POST['review_text']) || empty($_POST['review_text']))
		{
			$error = true;
			$messages[] = iaLanguage::get('empty_review');
		}
		elseif (!isset($_POST['review_item']) || empty($_POST['review_item']))
		{
			$error = true;
			$messages[] = iaLanguage::get('empty_rating');
		}
		else
		{
			if (!$review)
			{
				$iaSmarty = $iaCore->factory(iaCore::CORE, 'smarty');
				$review = array(
					'obj_id' => $listing,
					'item_type' => $item,
					'item_title' => $title,
					'item_url' => iaSmarty::ia_url(array('item' => $item, 'data' => $iaDb->row(iaDb::ALL_COLUMNS_SELECTION, "`id` = '$listing'", $item), 'type' => 'url')),
					'ratings' => array()
				);
				$data = $review;
				$data['ratings'] = serialize($data['ratings']);
				$review['id'] = $iaDb->insert($data, array('date_updated' => iaDb::FUNCTION_NOW), iaReview::getTable());
			}

			if (!$iaDb->exists('`review_id` = :review AND `member_id` = :user AND `session_id` = :session', array('review' => $review['id'], 'user' => $userId, 'session' => $sessionId), iaReview::getTableClicks()))
			{
				foreach ($star_list as $key => $max_star)
				{
					if (isset($_POST['review_item'][$key]))
					{
						$star = $_POST['review_item'][$key];
						if (0 < $star && $star <= $max_star)
						{
							if (!isset($review['ratings'][$key]) || !is_array($review['ratings'][$key]))
							{
								// first -> count, second -> current rate
								$review['ratings'][$key] = array(0, 0);
							}
							$rate = $review['ratings'][$key];
							$rate[1] = ( $rate[1] * $rate[0] + $star ) / ( $rate[0] + 1 );
							$rate[1] = number_format($rate[1], 2, '.', '');
							$rate[0] = $rate[0] + 1;
							$review['ratings'][$key] = $rate;
						}
						else
						{
							unset($_POST['review_item'][$key]);
						}
					}
				}
				$iaDb->update(array('id' => $review['id'], 'ratings' => serialize($review['ratings'])), null, array('date_updated' => iaDb::FUNCTION_NOW), iaReview::getTable());

				$entry = array(
					'review_id' => $review['id'],
					'member_id' => $userId,
					'item' => $item,
					'session_id' => $sessionId,
					'review_rates' => serialize($_POST['review_item']),
					'review_text' => iaSanitize::tags($_POST['review_text']),
					'status' => $iaCore->get('reviews_auto_approval') ? iaCore::STATUS_ACTIVE : iaCore::STATUS_APPROVAL
				);
				$iaDb->insert($entry, array('date_added' => iaDb::FUNCTION_NOW), iaReview::getTableClicks());
				$messages[] = iaLanguage::get('review_added');
			}

			$alreadyReviewed = true;
		}

		$iaView->setMessages($messages, $error ? iaView::ERROR : iaView::SUCCESS);
	}

	if (isset($_POST['review_comment']) && $itemConfiguration['comment_allowed'])
	{
		$reviewId = isset($_POST['review_id']) ? (int)$_POST['review_id'] : 0;

		if ($reviewId > 0)
		{
			$entry = array(
				'member_id' => $userId,
				'session_id' => $sessionId,
				'click_id' => $reviewId,
				'body' => iaSanitize::tags($_POST['review_comment']),
				'status' => $iaCore->get('reviews_comments_auto_approval') ? iaCore::STATUS_ACTIVE : iaCore::STATUS_APPROVAL
			);
			$iaDb->insert($entry, null, iaReview::getTableComments());

			if ($iaCore->get('reviews_comments_auto_approval'))
			{
				$iaDb->update(array('id' => $reviewId), '', array('comments' => '`comments` + 1'), iaReview::getTableClicks());
				$iaView->setMessages(iaLanguage::get('reviews_comment_added'), iaView::SUCCESS);
			}
			else
			{
				$iaView->setMessages(iaLanguage::get('reviews_comment_approval'), iaView::SUCCESS);
			}
		}
	}

	if ($review !== false)
	{
		$texts = $iaDb->getAll("SELECT r.*, u.username, u.fullname, u.avatar, IF (t.`type` is NULL, 'none', t.`type`) `type`
			FROM `{$iaCore->iaDb->prefix}reviews_clicks` r
				LEFT JOIN `{$iaCore->iaDb->prefix}members` u ON (u.`id` = r.`member_id`)
				LEFT JOIN `{$iaCore->iaDb->prefix}reviews_likes` t ON (t.`review_id` = r.`id` AND (t.`member_id` = '$userId' AND t.`member_id` != 0 OR t.`session_id` = '$sessionId'))
			WHERE r.`review_id` = '{$review['id']}' AND r.`item` = '$item' AND r.`status` = 'active'
			ORDER BY r.`date_added` DESC
			LIMIT " . $limit);

		$ids = array();
		if ($texts)
		{
			foreach ($texts as $key => $val)
			{
				$ids[] = $val['id'];
			}
			$ids = implode(',', $ids);
		}
		if ($ids)
		{
			$sql = "SELECT m.*, a.`username`, a.`id` `member_id`,
					IF (m.`member_id` > 0, IF (a.`fullname` != '', a.`fullname`, a.`username`), '" . iaLanguage::get('guest') . "') `author`,
				 	IF (t.`type` is NULL, 'none', t.`type`) `type`"
				. " FROM `{$iaCore->iaDb->prefix}reviews_comments` m "
					. "LEFT JOIN `{$iaCore->iaDb->prefix}members` a ON (m.`member_id` = a.`id`) "
					. "LEFT JOIN `{$iaCore->iaDb->prefix}reviews_likes` t ON (t.`member_id` = m.`member_id` AND t.`review_id` = m.`click_id` AND (m.`member_id` != 0 OR t.`session_id` = m.`session_id`)) "
				. "WHERE m.`click_id` IN ($ids) AND m.`status` = 'active' "
				. "ORDER BY m.`date` DESC ";

			if ($comments = $iaDb->getAll($sql))
			{
				foreach($comments as $comment)
				{
					$review_comments[$comment['click_id']][] = $comment;
				}
				unset($comments);
			}
		}
	}

	$iaView->assign('review_exists', $alreadyReviewed);
	$iaView->assign('review_texts', $texts);
	$iaView->assign('review_comments', $review_comments);
	$iaView->assign('configuration', $itemConfiguration);
	$iaView->assign('review', $review);

	$iaView->assign('session_id', $sessionId);
	$iaView->assign('reviews_title', $title);
	$iaView->assign('reviews_item', $item);
	$iaView->assign('reviews_listing', $listing);
}